#ifndef UIOBJECT_H
#define UIOBJECT_H

/*
    Copyright (C) 2004 Mark Boyd

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include<allegro.h>

class uiobjectlist
{
public:
int stopwaiting;
class uiobject *start;
uiobject *active;
int nobjects;
static BITMAP *vscreen;
void (*waitfun)(void);
uiobjectlist(void);
void mvs(void);
void kvs(void);
void add(uiobject *);
void remove(uiobject *);
void clickfun(int,int);
uiobject *getelt(int);
void wait(void);
static void rest50(void);
void (*catchchar[256])(void);
void (*catchechar[256])(void);
static void donothing(void);
};


class uiobject
{
public:
static uiobjectlist uol;
short isactive;
uiobject *next;
int left,top,right,bottom;
uiobject *parent;
int nkids;
uiobject * *kids;
int colour;
uiobject(int,int,int,int,int);
virtual ~uiobject();
void activate(void);
void deactivate(void);
void spawn(uiobject *);
void unspawn(uiobject *);
void clickfun(int,int);
virtual void vclickfun(int,int);
virtual void charfun(char){};
virtual void echarfun(char){};
void redraw(void);
virtual void vredraw(void)=0;
void mover(int,int);
int getl(void);
int gett(void);
};

class boringbox:public uiobject
{
char *title;
public:
boringbox(int,int,int,int,int,const char *);
~boringbox();
void vclickfun(int,int);
void vredraw(void);
};

class textbox:public uiobject
{
int icolour;
unsigned int length;
char *the_string;
unsigned int cursorpos;
public:
textbox(int,int,int,int,int,const char *);
~textbox();
char *getstr(void);
void vclickfun(int,int);
void charfun(char);
void echarfun(char);
void vredraw(void);
};

class text:public uiobject
{
char *the_text;
public:
text(int,int,int,const char *);
~text();
void vredraw(void);
};

class button:public uiobject
{
void (*doit)(button *);
char *strin;
public:
button(int,int,int,int,int,char *,void (*)(button *));
~button();
void vclickfun(int,int);
void vredraw(void);
};

class menu:public uiobject
{
int noptions;
int current;
char * *text;
BITMAP * store;
public:
menu(int,int,int,int,int,const char *const *);
~menu();
int getcurrent(void);
void vclickfun(int,int);
void vredraw(void);
};


class hslider:public uiobject
{
int maximum;
int state;
int col2;
public:
hslider(int,int,int,int,int,int,int);
int getstate(void);
void vclickfun(int,int);
void vredraw(void);
};


int maxlen(int,const char *const *);

#endif
